; PROforma, PROgs Font & Raster Manager
;
; routine to copy a piece of a bitmap
;
; (c) PROGS, Professional & Graphical Software
; written by Joachim Van der Auwera
; started 18 October 1995
;
    include win1_pf_bitm_bitmap_in
    include win1_inc_aid_mac
    section text
;
; local variables
l_from  equ  0  .l  address to copy from
l_to    equ  4  .l  address to copy to
l_left  equ  8  .w  and mask at left
l_right equ 10  .w  and mask at right
l.len   equ 12
; parameters
from    equ  0+36+l.len .l  bitmap to copy from
to      equ  4+36+l.len .l  bitmap to copy to
xsiz    equ  8+36+l.len .w
ysiz    equ 10+36+l.len .w
fromx   equ 12+36+l.len .w
fromy   equ 14+36+l.len .w
tox     equ 16+36+l.len .w
toy     equ 18+36+l.len .w
; register usage (compared with c code)
;   a0  bitmap from         d0  scratch
;   a1  bitmap to           d1  scratch
;   a2  address from        d2  scratch
;   a3  address to          d3  shift
;   a4                      d4  memory with remainder of prev byte
;   a5                      d5  memory with remainder of prev byte
;   a6                      d6  horizontal pixel counter
;   sp                      d7  line counter
_CopyArea xsub
    regsave d2-d7/a2-a3
    getssp  l.len

    move.l  from(sp),a0         ; info about size etc of bitmap to copy from
    move.l  to(sp),a1           ; info about size etc of bitmap to copy to

    ; calculate address to copy from
    moveq   #0,d0               ; clear upper word
    move.w  fromx(sp),d0        ; x from coordinate
    lsr.w   #2,d0               ; four pixels a byte
    bclr    #0,d0               ; make even
    move.w  fromy(sp),d1        ; y from coordinate
    mulu    b_linc(a0),d1       ; multiply with line increment
    add.l   d1,d0               ; address in bitmap
    add.l   b_base(a0),d0       ; address in memory
    move.l  d0,l_from(sp)       ; store it for later

    ; calculate address to copy to
    moveq   #0,d0               ; clear upper word
    move.w  tox(sp),d0          ; x to coordintate
    lsr.w   #2,d0               ; four pixels a byte
    bclr    #0,d0               ; make even
    move.w  toy(sp),d1          ; y to coordinate
    mulu    b_linc(a1),d1       ; multiply with line increment
    add.l   d1,d0               ; address in bitmap
    add.l   b_base(a1),d0       ; address in memory
    move.l  d0,l_to(sp)         ; store it for later

    ; initialise loop counter for each line
    move.w  ysiz(sp),d7         ; size of area to copy
    subq.w  #1,d7               ; adjust for dbf
    bmi     done                ; nothing to do -> ...

    ; calculate masks to and - left
    move.w  tox(sp),d0          ; where to copy to - have to mask destination
    andi.w  #7,d0               ; no of pixels
    subq.w  #8,d0               ; complement with 8
    neg.w   d0
    moveq   #-1,d1              ; mask
    lsl.b   d0,d1               ; shift to match
    move.w  d1,l_left(sp)       ; and mask - left

    ; calculate masks to and - right
    move.w  tox(sp),d0          ; where to copy to - have to mask destination
    add.w   xsiz(sp),d0         ; right edge
    andi.w  #7,d0               ; no of pixels
    moveq   #-1,d1              ; mask
    lsr.b   d0,d1               ; shift to match
    move.w  d1,l_right(sp)      ; and mask - right

    move.w  fromx(sp),d3        ; determine real direction
    andi.w  #7,d3               ; position in "from" byte
    move.w  tox(sp),d1
    andi.w  #7,d1               ; position in "to" byte
    sub.w   d1,d3               ; value to shift
    bpl     leftshift

; --- copy with shift right

rightshift                      ; shift right
    neg.w   d5
rightloop
    move.l  l_from(sp),a2       ; address to copy from
    move.l  l_to(sp),a3         ; address to copy to

    move.w  xsiz(sp),d6         ; no of pixels to copy

    ; handle part of byte at left
    move.w  tox(sp),d1          ; x destination
    andi.w  #7,d1
    subq.w  #8,d1               ; take 8 complement
    neg.w   d1
    sub.w   d1,d6               ; the number of pixels handled here
    move.w  fromx(sp),d1        ; x source
    andi.w  #7,d1
    subq.w  #8,d1               ; take 8 complement
    neg.w   d1
    moveq   #-1,d2              ; mask
    lsl.b   d1,d2
    not.b   d2                  ; mask to keep only bits to copy
    moveq   #0,d0               ; get green part from source
    move.b  (a2)+,d0
    and.b   d2,d0
    lsl.b   #8,d0
    lsr.w   d3,d0
    move.b  d0,d4               ; keep for next byte
    lsl.w   #8,d4
    lsr.w   #8,d0
    moveq   #0,d1               ; get red part from source
    move.b  (a2)+,d1
    and.b   d2,d1
    lsl.b   #8,d1
    lsr.w   d3,d1
    move.b  d1,d5               ; keep for next byte
    lsl.w   #8,d5
    lsr.w   #8,d1

    move.w  l_left(sp),d2       ; put in bitmap
    and.b   d2,(a3)
    or.b    d0,(a3)+
    and.b   d2,(a3)
    or.b    d1,(a3)+
rbody
    subq.w  #8,d6               ; we are going to copy another 8 pixels
    bmi.s   rbodyend            ; not enough pixels to go
    move.b  (a2)+,d0            ; copy a byte of the green stuff
    lsl.w   #8,d0
    lsr.w   d3,d0
    or.w    d4,d0
    move.b  d0,d4
    lsl.w   #8,d4
    lsr.w   #8,d0
    move.b  d0,(a3)+
    move.b  (a2)+,d1            ; copy a byte of the green stuff
    lsl.w   #8,d1
    lsr.w   d3,d1
    or.w    d5,d1
    move.b  d1,d5
    lsl.w   #8,d5
    lsr.w   #8,d1
    move.b  d1,(a3)+
    bra.s   rbody
rbodyend
    move.w  l_right(sp),d2      ; get mask
    not.b   d2
    moveq   #8,d6               ; shift amount
    sub.w   d3,d6
    move.b  (a2)+,d0            ; get grren stuff
    lsl.w   d6,d0
    or.w    d4,d0
    lsr.w   #8,d0
    and.w   d2,d0
    move.b  (a2)+,d1            ; get red stuff
    lsl.w   d6,d0
    or.w    d5,d1
    lsr.w   #8,d1
    and.w   d2,d1
    move.w  l_right(sp),d2      ; get mask
    and.b   d2,(a3)             ; and store the result
    or.b    d0,(a3)+
    and.b   d2,(a3)
    or.b    d1,(a3)+

    move.l  l_from(sp),a2       ; add line increment to source
    adda.w  b_linc(a0),a2
    move.l  a2,l_from(sp)
    move.l  l_from(sp),a3       ; add line increment to destination
    adda.w  b_linc(a1),a3
    move.l  a3,l_from(sp)
    dbf     d7,rightloop        ; copy next line
    bra     done

; --- copy with shift left

leftshift                       ; shift left
    ; calculate difference between address at left and right
    moveq   #0,d0
    move.w  xsiz(sp),d0         ; no of pixels to copy
    move.w  tox(sp),d1          ; no of pixels handled at left ..
    andi.w  #7,d1               ; .. in a word
    sub.w   d1,d0               ; subtract
    lsr.w   #2,d0               ; eight pixels for ..
    bclr    #0,d0               ; .. each two bytes
    addq.w  #4,d0               ; and two words at each end
    add.l   d0,l_from(sp)       ; adjust addresses according
    add.l   d0,l_to(sp)
leftloop
    move.l  l_from(sp),a2       ; address to copy from
    move.l  l_to(sp),a3         ; address to copy to

    move.w  xsiz(sp),d6         ; no of pixels to copy

    ; handle part of byte at right
    moveq   #0,d0               ; get red byte
    move.b  1(a2),d0
    lsl.w   d3,d0
    move.w  d0,d4
    lsr.w   #8,d4
    moveq   #0,d1               ; get green byte
    move.b  (a2),d0
    lsl.w   d3,d1
    move.w  d1,d5
    lsr.w   #8,d5

    move.w  tox(sp),d1
    add.w   xsiz(sp),d1
    and.w   #7,d1
    sub.w   d1,d6               ; the number of pixels handled here
    move.w  d6,d1               ; determine mask for source
    andi.w  #7,d1
    moveq   #-1,d2
    lsr.b   d1,d2
    not.b   d2
    clr.w   d0
    move.b  -(a2),d0            ; red stuff
    lsl.w   d3,d0
    clr.w   d1
    or.b    d4,d0
    move.w  d0,d4
    lsr.w   #8,d4
    and.b   d2,d0
    move.b  -(a2),d1            ; green stuff
    lsl.w   d3,d1
    or.b    d5,d1
    move.w  d1,d5
    lsr.w   #8,d5
    and.b   d2,d1
    move.w  l_right(sp),d2      ; right destination mask
    and.b   d2,-(a3)            ; and store the result
    or.b    d0,(a3)
    and.b   d2,-(a3)
    or.b    d1,(a3)
lbody
    subq.w  #8,d6               ; we are going to copy another 8 pixels
    bmi.s   lbodyend            ; not enough pixels to go
    moveq   #0,d0               ; copy a red byte
    move.b  -(a2),d0
    lsl.w   d3,d0
    or.b    d4,d0
    move.w  d0,d4
    lsr.w   #8,d4
    move.b  d0,-(a3)
    moveq   #0,d1               ; copy a red byte
    move.b  -(a2),d1
    lsl.w   d3,d1
    or.b    d5,d1
    move.w  d1,d5
    lsr.w   #8,d5
    move.b  d1,-(a3)
    bra.s   lbody
lbodyend
    move.w  l_left(sp),d2       ; get mask
    not.b   d2
    moveq   #0,d0
    move.b  -(a2),d0
    lsl.w   d3,d0
    or.b    d4,d0
    and.b   d2,d0
    moveq   #0,d1               ; copy a red byte
    move.b  -(a2),d1
    lsl.w   d3,d1
    or.b    d5,d1
    and.b   d2,d0
    move.w  l_left(sp),d2       ; get mask
    and.b   d2,-(a3)            ; and store the result
    or.b    d0,(a3)
    and.b   d2,-(a3)
    or.b    d1,(a3)

    move.l  l_from(sp),a2       ; add line increment to source
    adda.w  b_linc(a0),a2
    move.l  a2,l_from(sp)
    move.l  l_from(sp),a3       ; add line increment to destination
    adda.w  b_linc(a1),a3
    move.l  a3,l_from(sp)
    dbf     d7,leftloop         ; copy next line
done
    moveq   #0,d0               ; no error
    subend                      ; restore and return
;
    end
