/*
	PROforma, PROGS Font & Raster Manager

	test program for v1.10
	uses CORE linking to test only PFShowChar
	both with and without drawing bitmap driver to compare the speed

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 14 October 1995
*/

#include "io_h"
#include "sms_h"
#include "job_h"
#include "time_h"
#include "thing_h"

#include "PROforma_h"

extern Error PFShowChar(Gstate gstate, int code);

Bbox bbox={short2pt(720), short2pt(540),0,0};
ColourRGB colour={ 0, 0, 0 };

Error TimeDrawing(Gstate,Channel, int count, char *text);

Error init()
{
	Gstate gstate;
	Error err;
	Channel chid;

	err=IOOpen("ram1_cachetime_txt",OPEN_OVER,&chid);
	if (err) return err;

	LinkPROforma();
	err=PFGstateInit(PF_DRIVER_SCREEN,NULL,&bbox,&gstate,NULL);
	if (err) return err;

	err=PFColourRGB(gstate,&colour);
	if (err) return err;

	err=PFFontLoad(gstate,"Courier");
	if (err) return err;
	PFFontScale(gstate,short2pt(12));
	PFMoveTo(gstate,4*pt_hundred,4*pt_hundred);
	PFStringShow(gstate,"AA");	/* fille cache, !! set gstate->font !! */

	err=PFPageShow(gstate);
	if (err) return err;
				 
	/* the eye also wants something */
	err=PFPageShow(gstate);
	if (err) return err;

	/* test the speed of the fontcache */
	TimeDrawing(gstate,chid,200000,"draw some text");

	/* use dynamic config to replace bitmap draw by nop routintes */
	/* to determine which part of the time is used by bitmap driver */
	err=THINGCall(PF_THING_NAME,PF_THING_CNFG,1,"D mode4NoDraw_pfd");
	err=PFGstateInit(PF_DRIVER_SCREEN,NULL,&bbox,&gstate,NULL);
	if (err) return err;
	err=PFFontLoad(gstate,"Courier");
	if (err) return err;
	PFFontScale(gstate,short2pt(12));
	PFMoveTo(gstate,4*pt_hundred,4*pt_hundred);
	PFStringShow(gstate,"AA");	/* fille cache, !! set gstate->font !! */
	TimeDrawing(gstate,chid,200000,"draw some text without drawing");


	return err;
}

Error TimeDrawing(Gstate gstate, Channel chid, int count, char *text)
{
	char str[80],time[30];
	Time before,after;

	PFMoveTo(gstate, pt_hundred, short2pt(80));
	IOPutString(chid,"third cache test, one font at screen size",NULL);
	STRFormatPut(str,"%s, repeated %d times",text,count);
	IOPutString(chid,str,NULL);
	TIMEGet(&before);
	for (;count>0;count--)
		PFShowChar(gstate,'A');
	TIMEGet(&after);
	STRTime(before,time);
	STRFormatPut(str,"before %s",time);
	IOPutString(chid,str,NULL);
	STRTime(after,time);
	STRFormatPut(str,"after %s",time);
	IOPutString(chid,str,NULL);
	STRFormatPut(str,"time used %d seconds",after-before);
	IOPutString(chid,str,NULL);
	return ERR_OK;
}
